<?PHP
/************************************************************************/
/* NPDS V : Net Portal Dynamic System .                                 */
/* ===========================                                          */
/*                                                                      */
/* This version name NPDS Copyright (c) 2005 by Philippe Brunier        */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/************************************************************************/
/************************************************************************/
/* Module-Install                                                       */
/* --------------                                                       */
/*                                                                      */
/* Version 1.1 - 12 Juin 2005                                           */
/* --------------------------                                           */
/*                                                                      */
/* Développé par Boris                                                  */
/*                                                                      */
/* Intégration au coeur de Npds par Boris et Hotfirenet au 15/03/2005   */
/* Corrections et mise aux standard de NPDS par Boris le 12/06/2005     */
/*                                                                      */
/* Installeur inspiré du programme d'installation d'origine du module   */
/* Hot-Projet développé par Hotfirenet                                  */
/*                                                                      */
/************************************************************************/
function Access_Error () {
  if (file_exists("meta/meta.php"))
     include ("meta/meta.php");
  echo "<title>NPDS</title></head><body bgcolor=\"white\"><br /><p align=\"center\"><span style=\"font-size: 14px; font-family: Arial; font-weight: bold; color: red;\">";
  echo "Access Denied / Acc&egrave;s Refus&eacute;";
  if (cur_charset=="utf-8") echo" / &#x901A;&#x5165;&#x88AB;&#x5426;&#x8BA4;";
  echo "</span>";
  echo "<br /><br /><span style=\"font-size: 12px; font-family: Arial; font-weight: bold; color: black;\">NPDS - Portal System";
  echo "</span></p></body></html>";
  die();
}

if (strstr($ModPath,"..") || strstr($ModStart,"..") || stristr($ModPath, "script") || stristr($ModPath, "cookie") || stristr($ModPath, "iframe") || stristr($ModPath, "applet") || stristr($ModPath, "object") || stristr($ModPath, "meta") || stristr($ModStart, "script") || stristr($ModStart, "cookie") || stristr($ModStart, "iframe") || stristr($ModStart, "applet") || stristr($ModStart, "object") || stristr($ModStart, "meta")) {
   Access_Error();
}
if (!eregi("admin.php", $PHP_SELF)) {
   Access_Error();
}
global $pdst; $pdst="0";
global $language, $ModInstall, $ModDesinstall;
$result = mysql_query("select radminsuper from authors where aid='$aid'");
list($radminsuper) = mysql_fetch_row($result);
if ($radminsuper != 1) {
   Access_Error();
}

// *****************************
// * Fonctions de l'installeur *
// *****************************
function nmig_copyright() {
   $display = "<div style=\"text-align: center;\">\n";
   $display .= "Module-Install v1.1 & NPDS Module Installer Generator v1.1 - (C) <a href=\"http://www.lordi-depanneur.com\" target=\"_blank\" class=\"NOIR\">L'Ordi-Dépanneur</a> & <a href=\"http://www.hotfirenet.com\" target=\"_blank\" class=\"NOIR\">Hotfirenet</a> : 2005 - <a href=\"http://modules.npds.org/viewforum.php?forum=54\" target=\"_blank\" class=\"NOIR\">Forum</a>";
   $display .= "</div>\n";
   return $display;
}

// e1
function nmig_Start($name_module,$txtdeb) {
   global $ModInstall, $display;
   $display = "<div style=\"text-align: left;\">\n";
   if (isset($txtdeb) && $txtdeb != "") {
      $display .= aff_langue($txtdeb);
   } else {
      $display .= "<big><b>".installer_translate("Bonjour et bienvenue dans l'installation automatique du module")." \"".$name_module."\""."</b></big>\n";
      $display .= "<br /><br />\n";
      $display .= installer_translate("Ce programme d'installation va configurer votre site internet pour utiliser ce module.")."<br /><br />\n";
      $display .= "<i>".installer_translate("Cliquez sur \"Etape suivante\" pour continuer.")."</i><br /><br />\n";
   }
   $display .= "</div><div style=\"text-align: center;\">\n";
   $display .= "[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e2\" class=\"NOIR\">".installer_translate("Etape suivante")."</a>&nbsp;]<br />\n";
   $display .= "<br />\n";
   $display .= "</div>\n";
   $display .= nmig_copyright();
}

// e2
function nmig_License($licence_file) {
   global $ModInstall, $display;

   $myfile = @fopen($licence_file,"r");
   $licence_text = fread($myfile, filesize($licence_file));
   fclose($myfile);

   $display = "<br /><div class=\"HEADER\" style=\"text-align: center;\">\n";
   $display .= installer_translate("L'utilisation de NPDS et des modules est soumise à l'acceptation des termes de la licence GNU/GPL :");
   $display .= "</div><br />\n";
   $display .= "<div style=\"text-align: center;\">\n";
   $display .= "<textarea class=\"TEXTBOX_STANDARD\" name=\"licence\" cols=\"80\" rows=\"24\" readonly>".$licence_text."</textarea>";
   $display .= "<br />[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e3\" class=\"NOIR\">".installer_translate("Accepter")."</a>&nbsp; | &nbsp;<a href=\"admin.php?op=Modules\" class=\"ROUGE\">".installer_translate("Refuser")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

//e3
function nmig_AlertSql($sql,$tables) {
   global $ModInstall, $display, $NPDS_Prefix;

   $display = "<div style=\"text-align: left;\">\n";
   $display .= installer_translate("Le programme d'installation vas maintenant exécuter le script SQL pour configurer la base de donnée MySql.")."<br />\n";
   $display .= installer_translate("Si vous le souhaitez, vous pouvez exécuter ce script vous même, si vous souhaitez par exemple l'exécuter sur une autre base que celle du site. Dans ce cas, pensez à reparamétrer le fichier de configuration du module.")."<br /><br />\n";
   $display .= installer_translate("Voici le script SQL :")."<br /><br />\n";
   $display .= "</div>\n";
   ob_start();
   for ($i = 0; $i < count($sql); $i++) {
      for ($j = 0; $j < count($tables); $j++) {
         $sql[$i] = eregi_replace($tables[$j], $NPDS_Prefix.$tables[$j],$sql[$i]);
      }
      highlight_string($sql[$i]);
      echo "<br />";
   }
   $display .= ob_get_contents();
   ob_end_clean();
   $display .= "<br />\n";
   $display .= "<div style=\"text-align: center;\">\n";
   $display .= "[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e4\" class=\"NOIR\">".installer_translate("Configurer MySql (Recommandé)")."</a>&nbsp; | &nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e5\" class=\"ROUGE\">".installer_translate("Sauter cette étape")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// e4
function nmig_WriteSql($sql,$tables) {
   global $ModInstall, $display, $NPDS_Prefix;

   $display = "<div style=\"text-align: left;\">\n";
   for ($i = 0; $i < count($sql) && !isset($erreur); $i++) {
      for ($j = 0; $j < count($tables); $j++) {
         $sql[$i] = eregi_replace($tables[$j], $NPDS_Prefix.$tables[$j],$sql[$i]);
      }
      mysql_query($sql[$i]) or $erreur = mysql_error();
   }
   if (isset($erreur)) {
      $display .= installer_translate("Une erreur est survenue lors de l'exécution du script SQL. Mysql a répondu :");
      ob_start();
      highlight_string($erreur);
      $display .= ob_get_contents();
      ob_end_clean();
      $display .= installer_translate("Veuillez l'exécuter manuellement via phpMyAdmin.")."<br /><br />\n";
      $display .= installer_translate("Voici le script SQL :")."<br /><br />\n";
      ob_start();
      for ($i = 0; $i < count($sql); $i++) {
         highlight_string($sql[$i]);
         echo "<br />";
      }
      $display .= ob_get_contents();
      ob_end_clean();
      $display .= "<br />\n";
   } else {
      $display .= installer_translate("La configuration de la base de donnée MySql a réussie !")."<br />\n";
   }
   $display .= "</div><div style=\"text-align: center;\">\n";
   $display .= "<br />[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e5\" class=\"NOIR\">".installer_translate("Etape suivante")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// e5
function nmig_AlertConfig($list_fich) {
   global $ModInstall, $display;

   $display = "<div style=\"text-align: left;\">\n";
   $display .= installer_translate("Le programme d'installation vas maintenant modifier le(s) fichier(s) suivant(s) :")."<br /><br />\n";
   for ($i = 0; $i < count($list_fich[0]); $i++) {
      $display .= $list_fich[0][$i]."<br />\n";
   }
   $display .= "</div><div style=\"text-align: center;\">\n";
   $display .= "<br />\n";
   $display .= "[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e6\" class=\"ROUGE\">".installer_translate("Modifier le(s) fichier(s)")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// e6
function nmig_WriteConfig($list_fich,$try_Chmod) {
   global $ModInstall, $display;

   $writeAllFiles = 1;

   $display .= "<div style=\"text-align: left;\">\n";
   $file_created = 0;
   for ($i = 0; $i < count($list_fich[0]); $i++) {
      if (!file_exists($list_fich[0][$i])) {
         $file = fopen($list_fich[0][$i7], "w");
         fclose($file);
         $file_created = 1;
      }

      if ($list_fich[0][$i] == "admin/extend-modules.txt" || $list_fich[0][$i] == "modules/include/body_onload.inc") {
         $file = fopen($list_fich[0][$i], "r");
         $txtconfig = fread($file,filesize($list_fich[0][$i]));
         fclose($file);
         $debut = strpos($list_fich[1][$i],"[nom]") + 5;
         $fin = strpos($list_fich[1][$i],"[/nom]");
         if (ereg(substr($list_fich[1][$i],$debut,$fin-$debut),$txtconfig)) {
            $display .= installer_translate("Les paramètres sont déjà inscrit dans le fichier \"").$list_fich[0][$i]."\".<br />\n";
         } else {
            if($try_Chmod) {
            @chmod($list_fich[0][$i], 666);
         }
            $file = @fopen($list_fich[0][$i], "r+");
            @fread($file,filesize($list_fich[0][$i]));
            if (@fwrite($file, $list_fich[1][$i])) {
               fclose($file);
               $display .= installer_translate("Les paramètres ont été correctement écrit dans le fichier \"").$list_fich[0][$i]."\".<br />\n";
            } else {
               $writeAllFiles = 0;
               $display .= installer_translate("Impossible d'écrire dans le fichier \"").$list_fich[0][$i]."\". ".installer_translate("Veuillez éditer ce fichier manuellement ou réessayez en tentant de faire un chmod automatique sur le(s) fichier(s) concernés.")."<br /><br />\n";
               $display .= installer_translate("Voici le code à taper dans le fichier :")."<br /><br />\n";
               $display .= "</div>\n";
               $display .= "<div class=\"CODE\">\n";
               ob_start();
               highlight_string($list_fich[1][$i]);
               $display .= ob_get_contents();
               ob_end_clean();
               $display .= "<br />\n";
            }
         }
      } else {
         $file = fopen($list_fich[0][$i], "r");
         $txtconfig = fread($file,filesize($list_fich[0][$i]));
         fclose($file);
         if (!$file_created) {
            $debut = strpos($txtconfig,"?>");
            $txtconfig = substr($txtconfig,0,$debut-1)."\n".$list_fich[1][$i]."\n?>";
         } else {
            $txtconfig = "<?\n".$list_fich[1][$i]."\n?>";
         }
         if ($try_Chmod) {
            @chmod($list_fich[0][$i], 666);
         }
         $file = @fopen($list_fich[0][$i], "w");
         @fread($file,filesize($list_fich[0][$i]));
         if (@fwrite($file, $txtconfig)) {
            fclose($file);
            $display .= installer_translate("Les paramètres ont été correctement écrit dans le fichier \"").$list_fich[0][$i]."\".<br />\n";
         } else {
            $writeAllFiles = 0;
            $display .= installer_translate("Impossible d'écrire dans le fichier \"").$list_fich[0][$i]."\". ".installer_translate("Veuillez éditer ce fichier manuellement ou réessayez en tentant de faire un chmod automatique sur le(s) fichier(s) concernés.")."<br />\n";
            $display .= installer_translate("Voici le code à taper dans le fichier :")."<br /><br />\n";
            $display .= "</div>\n";
            $display .= "<div class=\"CODE\">\n";
            ob_start();
            highlight_string($list_fich[1][$i]);
            $display .= ob_get_contents();
            ob_end_clean();
            $display .= "<br />\n";
         }
      }
   }
   $display .= "</div><br />\n";
   $display .= "<div style=\"text-align: center;\">\n";
   $display .= "[";
   if (!$writeAllFiles) {
      $display .= "&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e6&amp;try_Chmod=1\" class=\"ROUGE\">".installer_translate("Réessayer avec chmod automatique")."</a>&nbsp;] | [";
   }
   $display .= "&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e7\"";
   if (!$writeAllFiles) {
      $display .= "class=\"NOIR\">";
   } else {
      $display .= "class=\"ROUGE\">";
   }
   $display .= installer_translate("Etape suivante")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// e7
function nmig_AlertBloc($blocs) {
   global $ModInstall, $display;

   $display = "<div style=\"text-align: left;\">\n";
   $display .= installer_translate("Vous pouvez choisir maintenant de créer automatiquement un(des) bloc(s) à droite ou à gauche. Cliquer sur \"Créer le(s) bloc(s) à gauche\" ou \"Créer le(s) bloc(s) à droite\" selon votre choix. (Vous pourrez changer leurs positions par la suite dans le panneau d'administration --> Blocs)")."<br />\n";
   $display .= installer_translate("Si vous préférez créer vous même le(s) bloc(s), cliquez sur 'Sauter cette étape et afficher le code du(des) bloc(s)' pour visualiser le code à taper dans le(s) bloc(s).")."<br /><br />\n";
   $display .= installer_translate("Voici la description du(des) bloc(s) qui sera(seront) créé(s) :")."<br /><br />\n";
   $display .= "</div>\n";
   ob_start();
   for ($i = 0; $i < count($blocs[0]); $i++) {
      echo "<li>Bloc n°".$i." : ".$blocs[8][$i]."<br />";
   }
   $display .= ob_get_contents();
   ob_end_clean();
   $display .= "<div style=\"text-align: center;\">\n";
   $display .= "<br />\n";
   $display .= "[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e8&amp;posbloc=l\" class=\"NOIR\">".installer_translate("Créer le(s) bloc(s) à gauche")."</a>&nbsp; | &nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e8&amp;posbloc=r\" class=\"NOIR\">".installer_translate("Créer le(s) bloc(s) à droite")."</a>&nbsp; | &nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e8&amp;posbloc=0\" class=\"ROUGE\">".installer_translate("Sauter cette étape et afficher le code du(des) bloc(s)")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// e8
function nmig_WriteBloc($blocs,$posbloc) {
   global $ModInstall, $display;

   $display = "<div style=\"text-align: left;\">\n";
   if ($posbloc) {
      if ($blocs[2] == "") {
         $blocs[2] = $blocs[3];
      }
      if ($posbloc == "l") {
         $posblocM = "L";
      }
      if ($posbloc == "r") {
         $posblocM = "R";
      }
      for ($i = 0; $i < count($blocs[0]) && !isset($erreur); $i++) {
         mysql_query("INSERT INTO ".$posbloc."blocks (`id`, `title`, `content`, `member`, `".$posblocM."index`, `cache`, `actif`, `aide`) VALUES ('', '".$blocs[0][$i]."', '".$blocs[1][$i]."', '".$blocs[2][$i]."', '".$blocs[4][$i]."', '".$blocs[5][$i]."', '".$blocs[6][$i]."', '".$blocs[7][$i]."');") or $erreur = mysql_error();
      }
      if (isset($erreur)) {
         $display .= installer_translate("Une erreur est survenue lors de la configuration du(des) bloc(s). Mysql a répondu :");
         ob_start();
         highlight_string($erreur);
         $display .= ob_get_contents();
         ob_end_clean();
         $display .= installer_translate("Veuillez configurer manuellement le(s) bloc(s).")."<br /><br />\n";
         $display .= installer_translate("Voici le code du(des) bloc(s) :")."<br /><br />\n";
         ob_start();
         for ($i = 0; $i < count($blocs[0]); $i++) {
            echo "Bloc n° ".$i."<br />";
            highlight_string($blocs[1][$i]);
            echo "<br />\n";
         }
         $display .= ob_get_contents();
         ob_end_clean();
      } else {
         $display .= installer_translate("La configuration du(des) bloc(s) a réussie !")."<br />\n";
         $display .= "<br />\n";
      }
   } else {
      $display .= installer_translate("Vous avez choisi de configurer manuellement vos blocs. Voici le contenu de ceux-ci :")."<br /><br />";
      ob_start();
         for($i = 0; $i < count($blocs[0]); $i++) {
            echo "Bloc n° ".$i."<br />";
            highlight_string($blocs[1][$i]);
            echo "<br />\n";
         }
      $display .= ob_get_contents();
      ob_end_clean();
   }
   $display .= "</div><div style=\"text-align: center;\">\n";
   $display .= "[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e9\" class=\"NOIR\">".installer_translate("Etape suivante")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// e9
function nmig_txt($txtfin) {
   global $ModInstall, $display;

   $display = "<div style=\"text-align: left;\">\n";
   $display .= "<big><b>".aff_langue($txtfin)."</b></big>\n";
   $display .= "<br /><br />\n";
   $display .= "</div><div style=\"text-align: center;\">\n";
   $display .= "<br />[&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModInstall=".$ModInstall."&amp;nmig=e10\" class=\"NOIR\">".installer_translate("Etape suivante")."</a>&nbsp;]<br />\n";
   $display .= "</div>\n";
   $display .= "<br />\n";
   $display .= nmig_copyright();
}

// e10
function nmig_End($name_module, $end_link) {
   global $ModInstall, $display;

   mysql_query("UPDATE ".$NPDS_Prefix."modules SET minstall='1' WHERE mnom='".$ModInstall."'");
   $display = "<div style=\"text-align: left;\">\n";
   $display .= "<big><b>".installer_translate("L'installation automatique du module")." \"".$name_module."\" ".installer_translate("est terminée !")."\n";
   $display .= "<br /><br />\n";
   $display .= "</b></big>\n";
   $display .= "</div><div style=\"text-align: center;\">\n";
   $display .= "[&nbsp;<a href=\"".$end_link."\" class=\"NOIR\">".installer_translate("Terminer")."</a>&nbsp;]<br />\n";
   $display .= "</div><br />\n";
   $display .= nmig_copyright();
}

// ************************
// * Affichage de la page *
// ************************
   if (!isset($try_Chmod)) {
      $try_Chmod = 0;
   }

   if ($ModInstall != "" && $ModDesinstall == "") {
      if ($subop == "install") {
         $result = mysql_query("UPDATE ".$NPDS_Prefix."modules SET minstall='1' WHERE mnom= '".$ModInstall."'");
         redirect_url("admin.php?op=Modules");
      }
      include_once("language/lang-install-$language.php");

      if (file_exists("modules/".$ModInstall."/install.conf.php")) {
         include("modules/".$ModInstall."/install.conf.php");
      } else {
         include("header.php");
         GraphicAdmin($hlpfile);
         echo "<table width=\"100%\" cellspacing=\"2\" cellpadding=\"2\" border=\"0\"><tr><td class=\"HEADER\">\n";
         echo adm_translate("Gestion, Installation Modules");
         echo "</td></tr></table>\n";
         echo "<div style=\"text-align: center;\">".installer_translate("Fichier de configuration absent. Installation/désinstallation impossible.")."<br /><br />[ <a href=\"JavaScript:history.go(-1)\" class=\"ROUGE\">".installer_translate("Retour en arrière")."</a> ]</div><br /><br />".nmig_copyright();
         include("footer.php");
         die();
      }
      if (file_exists("modules/".$ModInstall."/licence-".$language.".txt")) {
         $licence_file = "modules/".$ModInstall."/licence-".$language.".txt";
      } else {
         $licence_file = "modules/".$ModInstall."/licence-english.txt";
      }

      switch($nmig) {
         case "e2":
            nmig_License($licence_file);
            break;

         case "e3":
            if (isset($sql[0]) && $sql[0] != "") { nmig_AlertSql($sql,$tables); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e5\";</script>"; }
            break;   

         case "e4":
            if (isset($sql[0]) && $sql[0] != "") { nmig_WriteSql($sql,$tables); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e5\";</script>"; }
            break;

         case "e5":
            if (isset($list_fich) && count($list_fich[0]) && $list_fich[0][0] != "") { nmig_AlertConfig($list_fich); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e7\";</script>"; }    
            break;

         case "e6":
            if (isset($list_fich) && count($list_fich[0])) { nmig_WriteConfig($list_fich, $try_Chmod); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e7\";</script>"; }    
            break;

         case "e7":
            if (isset($blocs) && count($blocs[0]) && $blocs[0][0] != "") { nmig_AlertBloc($blocs); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e9\";</script>"; }
            break;

         case "e8":
            if (isset($blocs) && count($blocs[0]) && $blocs[0][0] != "") { nmig_WriteBloc($blocs, $posbloc); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e9\";</script>"; }
            break;

         case "e9":
            if (isset($txtfin) && $txtfin != "") { nmig_txt($txtfin); }
            else { echo "<script type=\"text/javascript\" language=\"JavaScript\">window.location = \"admin.php?op=Module-Install&ModInstall=".$ModInstall."&nmig=e10\";</script>"; }
            break;

         case "e10":
            if (!isset($end_link) || $end_link == "") { $end_link = "admin.php?op=Modules"; }
            nmig_End($name_module, $end_link);
            break;

         default:
            nmig_Start($name_module,$txtdeb);
            break;
      }
   } elseif ($ModInstall == "" && $ModDesinstall != "") {
      if ($subop == "desinst") {
         $result = mysql_query("UPDATE ".$NPDS_Prefix."modules SET minstall='0' WHERE mnom= '".$ModDesinstall."'");
         redirect_url("admin.php?op=Modules");
      }

      include_once("language/lang-install-$language.php");

      $display = "<div style=\"text-align: left;\"><br /><big><b>".installer_translate("Désinstaller le module ").$ModDesinstall.".</b></big><br /><br />".installer_translate("La désinstallation des modules n'est pas prise en charge de façon automatique à l'heure actuelle.")."<br />".installer_translate("Vous devez désinstaller le module manuellement. Pour cela, référez vous au fichier install.txt de l'archive du module, et faites les opérations inverses de celles décrites dans la section \"Installation manuelle\", et en partant de la fin.")."<br />".installer_translate("Enfin, pour pouvoir réinstaller le module par la suite avec Module-Install, cliquez sur le bouton \"Marquer le module comme désinstallé\".")."<br /><br />\n";
      $display .= "</div><div style=\"text-align: center;\">[&nbsp;<a href=\"JavaScript:history.go(-1)\" class=\"NOIR\">".installer_translate("Retour")."</a>&nbsp;] [&nbsp;<a href=\"admin.php?op=Module-Install&amp;ModDesinstall=".$ModDesinstall."&amp;subop=desinst\" class=\"ROUGE\">".installer_translate("Marquer le module comme désinstallé")."</a>&nbsp;]<br />\n";
      $display .= "</div><br />\n";
      $display .= nmig_copyright();
   }

   include("header.php");
   GraphicAdmin($hlpfile);
   Opentable();
      echo "<table width=\"100%\" cellspacing=\"2\" cellpadding=\"2\" border=\"0\"><tr><td class=\"HEADER\">\n";
      echo adm_translate("Gestion, Installation Modules");
      echo "</td></tr></table>\n";
      echo $display;
   Closetable();
   include("footer.php");
?>